<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<html lang="en">

<head>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
  <title>LCOV - coverage.info - proyecto/fsm.vhd</title>
  <link rel="stylesheet" type="text/css" href="../gcov.css">
</head>

<body>

  <table width="100%" border=0 cellspacing=0 cellpadding=0>
    <tr><td class="title">LCOV - code coverage report</td></tr>
    <tr><td class="ruler"><img src="../glass.png" width=3 height=3 alt=""></td></tr>

    <tr>
      <td width="100%">
        <table cellpadding=1 border=0 width="100%">
          <tr>
            <td width="10%" class="headerItem">Current view:</td>
            <td width="35%" class="headerValue"><a href="../index.html">top level</a> - <a href="index.html">proyecto</a> - fsm.vhd<span style="font-size: 80%;"> (source / <a href="fsm.vhd.func-sort-c.html">functions</a>)</span></td>
            <td width="5%"></td>
            <td width="15%"></td>
            <td width="10%" class="headerCovTableHead">Hit</td>
            <td width="10%" class="headerCovTableHead">Total</td>
            <td width="15%" class="headerCovTableHead">Coverage</td>
          </tr>
          <tr>
            <td class="headerItem">Test:</td>
            <td class="headerValue">coverage.info</td>
            <td></td>
            <td class="headerItem">Lines:</td>
            <td class="headerCovTableEntry">22</td>
            <td class="headerCovTableEntry">66</td>
            <td class="headerCovTableEntryLo">33.3 %</td>
          </tr>
          <tr>
            <td class="headerItem">Date:</td>
            <td class="headerValue">2023-02-09 17:19:34</td>
            <td></td>
            <td class="headerItem">Functions:</td>
            <td class="headerCovTableEntry">7</td>
            <td class="headerCovTableEntry">7</td>
            <td class="headerCovTableEntryHi">100.0 %</td>
          </tr>
          <tr><td><img src="../glass.png" width=3 height=3 alt=""></td></tr>
        </table>
      </td>
    </tr>

    <tr><td class="ruler"><img src="../glass.png" width=3 height=3 alt=""></td></tr>
  </table>

  <table cellpadding=0 cellspacing=0 border=0>
    <tr>
      <td><br></td>
    </tr>
    <tr>
      <td>
<pre class="sourceHeading">          Line data    Source code</pre>
<pre class="source">
<a name="1"><span class="lineNum">       1 </span><span class="lineCov">          6 : library ieee;</span></a>
<a name="2"><span class="lineNum">       2 </span>            : use ieee.std_logic_1164.all;</a>
<a name="3"><span class="lineNum">       3 </span>            : use ieee.numeric_std.all;</a>
<a name="4"><span class="lineNum">       4 </span>            : </a>
<a name="5"><span class="lineNum">       5 </span>            : library src_lib;</a>
<a name="6"><span class="lineNum">       6 </span>            : use src_lib.edc_common.all;</a>
<a name="7"><span class="lineNum">       7 </span>            : </a>
<a name="8"><span class="lineNum">       8 </span><span class="lineCov">        158 : entity fsm is</span></a>
<a name="9"><span class="lineNum">       9 </span>            : </a>
<a name="10"><span class="lineNum">      10 </span>            :     port (</a>
<a name="11"><span class="lineNum">      11 </span>            :         clk   : in std_logic;</a>
<a name="12"><span class="lineNum">      12 </span>            :         reset : in std_logic;</a>
<a name="13"><span class="lineNum">      13 </span>            :         </a>
<a name="14"><span class="lineNum">      14 </span>            :         -- connection to prbs module:</a>
<a name="15"><span class="lineNum">      15 </span>            :         prbs_enable : out std_ulogic;</a>
<a name="16"><span class="lineNum">      16 </span>            :         prbs_signo   : in std_ulogic;</a>
<a name="17"><span class="lineNum">      17 </span>            : </a>
<a name="18"><span class="lineNum">      18 </span>            :         -- connection to interpolator</a>
<a name="19"><span class="lineNum">      19 </span>            :         hinf: out complex10;</a>
<a name="20"><span class="lineNum">      20 </span>            :         hsup: out complex10;</a>
<a name="21"><span class="lineNum">      21 </span>            :         valid: out std_ulogic;</a>
<a name="22"><span class="lineNum">      22 </span>            :         estim_valid: in std_ulogic;</a>
<a name="23"><span class="lineNum">      23 </span>            : </a>
<a name="24"><span class="lineNum">      24 </span>            :         -- connection to dpmemory</a>
<a name="25"><span class="lineNum">      25 </span>            :         data: in std_logic_vector(19 downto 0);</a>
<a name="26"><span class="lineNum">      26 </span>            :         addr: out std_logic_vector(10 downto 0);</a>
<a name="27"><span class="lineNum">      27 </span>            :         write_enable: out std_logic;</a>
<a name="28"><span class="lineNum">      28 </span>            : </a>
<a name="29"><span class="lineNum">      29 </span>            :         start_estimation : in std_ulogic</a>
<a name="30"><span class="lineNum">      30 </span>            : </a>
<a name="31"><span class="lineNum">      31 </span>            :     );</a>
<a name="32"><span class="lineNum">      32 </span>            : end entity;</a>
<a name="33"><span class="lineNum">      33 </span>            : </a>
<a name="34"><span class="lineNum">      34 </span>            : architecture architecture_fsm of fsm is</a>
<a name="35"><span class="lineNum">      35 </span>            : </a>
<a name="36"><span class="lineNum">      36 </span>            :     type state_type is (wait_interp, inf_pilot, sup_pilot, act_interp, act_prbs, rest);</a>
<a name="37"><span class="lineNum">      37 </span><span class="lineCov">          2 :     signal state, p_state : state_type; </span></a>
<a name="38"><span class="lineNum">      38 </span><span class="lineCov">         10 :     signal counter : unsigned(3 downto 0);</span></a>
<a name="39"><span class="lineNum">      39 </span><span class="lineCov">         10 :     signal p_counter : unsigned(3 downto 0);</span></a>
<a name="40"><span class="lineNum">      40 </span><span class="lineCov">         46 :     signal addr_low, p_addr_low : std_logic_vector(10 downto 0);</span></a>
<a name="41"><span class="lineNum">      41 </span><span class="lineCov">         46 :     signal addr_high, p_addr_high : std_logic_vector(10 downto 0);</span></a>
<a name="42"><span class="lineNum">      42 </span><span class="lineCov">         42 :     signal buffer_low : std_logic_vector(19 downto 0);</span></a>
<a name="43"><span class="lineNum">      43 </span><span class="lineCov">         42 :     signal buffer_high : std_logic_vector(19 downto 0);</span></a>
<a name="44"><span class="lineNum">      44 </span>            : </a>
<a name="45"><span class="lineNum">      45 </span><span class="lineCov">          4 :     signal sign_high, sign_low : std_ulogic;</span></a>
<a name="46"><span class="lineNum">      46 </span>            :     </a>
<a name="47"><span class="lineNum">      47 </span>            :     -- signal next_pilot: std_logic;</a>
<a name="48"><span class="lineNum">      48 </span>            :     </a>
<a name="49"><span class="lineNum">      49 </span>            : begin</a>
<a name="50"><span class="lineNum">      50 </span>            : </a>
<a name="51"><span class="lineNum">      51 </span><span class="lineCov">         54 :     sync: process (reset, clk)</span></a>
<a name="52"><span class="lineNum">      52 </span>            :     begin</a>
<a name="53"><span class="lineNum">      53 </span><span class="lineCov">          6 :         if reset = '1' then</span></a>
<a name="54"><span class="lineNum">      54 </span><span class="lineNoCov">          0 :             state &lt;= rest;</span></a>
<a name="55"><span class="lineNum">      55 </span><span class="lineCov">          6 :         elsif rising_edge(clk) then</span></a>
<a name="56"><span class="lineNum">      56 </span><span class="lineNoCov">          0 :             state &lt;= p_state;</span></a>
<a name="57"><span class="lineNum">      57 </span><span class="lineNoCov">          0 :             counter &lt;= p_counter;</span></a>
<a name="58"><span class="lineNum">      58 </span><span class="lineNoCov">          0 :             addr_high &lt;= p_addr_high;</span></a>
<a name="59"><span class="lineNum">      59 </span><span class="lineCov">         10 :             addr_low &lt;= p_addr_low;</span></a>
<a name="60"><span class="lineNum">      60 </span>            :         end if;</a>
<a name="61"><span class="lineNum">      61 </span>            :     end process;</a>
<a name="62"><span class="lineNum">      62 </span>            : </a>
<a name="63"><span class="lineNum">      63 </span>            : </a>
<a name="64"><span class="lineNum">      64 </span><span class="lineCov">        750 :     state_manage: process (all)</span></a>
<a name="65"><span class="lineNum">      65 </span>            :     begin</a>
<a name="66"><span class="lineNum">      66 </span>            :         </a>
<a name="67"><span class="lineNum">      67 </span><span class="lineCov">          4 :         p_state &lt;= state;</span></a>
<a name="68"><span class="lineNum">      68 </span>            : </a>
<a name="69"><span class="lineNum">      69 </span><span class="lineCov">          4 :         case state is</span></a>
<a name="70"><span class="lineNum">      70 </span>            :             when rest =&gt;</a>
<a name="71"><span class="lineNum">      71 </span><span class="lineNoCov">          0 :                 p_counter &lt;= (others =&gt; '0');</span></a>
<a name="72"><span class="lineNum">      72 </span><span class="lineNoCov">          0 :                 prbs_enable &lt;= '0';</span></a>
<a name="73"><span class="lineNum">      73 </span><span class="lineNoCov">          0 :                 p_addr_low &lt;= (others =&gt; '0');</span></a>
<a name="74"><span class="lineNum">      74 </span><span class="lineNoCov">          0 :                 p_addr_high &lt;= &quot;00000001100&quot;;</span></a>
<a name="75"><span class="lineNum">      75 </span><span class="lineNoCov">          0 :                 valid &lt;= '0';</span></a>
<a name="76"><span class="lineNum">      76 </span>            : </a>
<a name="77"><span class="lineNum">      77 </span><span class="lineNoCov">          0 :                 if start_estimation = '1' then</span></a>
<a name="78"><span class="lineNum">      78 </span><span class="lineNoCov">          0 :                     p_state &lt;= inf_pilot;</span></a>
<a name="79"><span class="lineNum">      79 </span>            :                 else </a>
<a name="80"><span class="lineNum">      80 </span><span class="lineNoCov">          0 :                     p_state &lt;= rest;</span></a>
<a name="81"><span class="lineNum">      81 </span>            :                 end if;</a>
<a name="82"><span class="lineNum">      82 </span>            : </a>
<a name="83"><span class="lineNum">      83 </span>            :         </a>
<a name="84"><span class="lineNum">      84 </span>            :             when inf_pilot =&gt;</a>
<a name="85"><span class="lineNum">      85 </span><span class="lineNoCov">          0 :                 addr &lt;= addr_low;</span></a>
<a name="86"><span class="lineNum">      86 </span><span class="lineNoCov">          0 :                 buffer_low &lt;= data;</span></a>
<a name="87"><span class="lineNum">      87 </span><span class="lineNoCov">          0 :                 p_state &lt;= sup_pilot;</span></a>
<a name="88"><span class="lineNum">      88 </span>            : </a>
<a name="89"><span class="lineNum">      89 </span>            :             </a>
<a name="90"><span class="lineNum">      90 </span>            :             when sup_pilot =&gt;</a>
<a name="91"><span class="lineNum">      91 </span><span class="lineNoCov">          0 :                 if counter = 0 then</span></a>
<a name="92"><span class="lineNum">      92 </span><span class="lineNoCov">          0 :                     p_counter &lt;= counter + 1;</span></a>
<a name="93"><span class="lineNum">      93 </span><span class="lineNoCov">          0 :                     sign_low &lt;= prbs_signo;</span></a>
<a name="94"><span class="lineNum">      94 </span><span class="lineNoCov">          0 :                     addr &lt;= addr_high;</span></a>
<a name="95"><span class="lineNum">      95 </span>            :                 </a>
<a name="96"><span class="lineNum">      96 </span><span class="lineNoCov">          0 :                 elsif counter &lt; 12 then</span></a>
<a name="97"><span class="lineNum">      97 </span><span class="lineNoCov">          0 :                     p_counter &lt;= counter + 1;</span></a>
<a name="98"><span class="lineNum">      98 </span>            : </a>
<a name="99"><span class="lineNum">      99 </span><span class="lineNoCov">          0 :                 elsif counter = 12 then</span></a>
<a name="100"><span class="lineNum">     100 </span><span class="lineNoCov">          0 :                     p_counter &lt;= (others =&gt; '0');</span></a>
<a name="101"><span class="lineNum">     101 </span><span class="lineNoCov">          0 :                     p_state &lt;= act_interp;</span></a>
<a name="102"><span class="lineNum">     102 </span><span class="lineNoCov">          0 :                     buffer_high &lt;= data;</span></a>
<a name="103"><span class="lineNum">     103 </span><span class="lineNoCov">          0 :                     sign_high &lt;= prbs_signo;</span></a>
<a name="104"><span class="lineNum">     104 </span>            :                 end if;</a>
<a name="105"><span class="lineNum">     105 </span>            :             </a>
<a name="106"><span class="lineNum">     106 </span>            :             when act_interp =&gt; </a>
<a name="107"><span class="lineNum">     107 </span><span class="lineNoCov">          0 :                 if sign_low then</span></a>
<a name="108"><span class="lineNum">     108 </span><span class="lineNoCov">          0 :                     hinf.re &lt;= -signed(buffer_low(19 downto 10));</span></a>
<a name="109"><span class="lineNum">     109 </span><span class="lineNoCov">          0 :                     hinf.im &lt;= -signed(buffer_low(9 downto 0));</span></a>
<a name="110"><span class="lineNum">     110 </span>            :                 else</a>
<a name="111"><span class="lineNum">     111 </span><span class="lineNoCov">          0 :                     hinf.re &lt;= signed(buffer_low(19 downto 10));</span></a>
<a name="112"><span class="lineNum">     112 </span><span class="lineNoCov">          0 :                     hinf.im &lt;= signed(buffer_low(9 downto 0));                    </span></a>
<a name="113"><span class="lineNum">     113 </span>            :                 end if;</a>
<a name="114"><span class="lineNum">     114 </span>            : </a>
<a name="115"><span class="lineNum">     115 </span><span class="lineNoCov">          0 :                 if sign_high then</span></a>
<a name="116"><span class="lineNum">     116 </span><span class="lineNoCov">          0 :                     hsup.re &lt;= -signed(buffer_high(19 downto 10));</span></a>
<a name="117"><span class="lineNum">     117 </span><span class="lineNoCov">          0 :                     hsup.im &lt;= -signed(buffer_high(9 downto 0));</span></a>
<a name="118"><span class="lineNum">     118 </span>            :                 else</a>
<a name="119"><span class="lineNum">     119 </span><span class="lineNoCov">          0 :                     hsup.re &lt;= signed(buffer_high(19 downto 10));</span></a>
<a name="120"><span class="lineNum">     120 </span><span class="lineNoCov">          0 :                     hsup.im &lt;= signed(buffer_high(9 downto 0));</span></a>
<a name="121"><span class="lineNum">     121 </span>            :                 end if;</a>
<a name="122"><span class="lineNum">     122 </span>            :                 </a>
<a name="123"><span class="lineNum">     123 </span><span class="lineNoCov">          0 :                 valid &lt;= '1';</span></a>
<a name="124"><span class="lineNum">     124 </span><span class="lineNoCov">          0 :                 p_state &lt;= wait_interp;</span></a>
<a name="125"><span class="lineNum">     125 </span>            :             </a>
<a name="126"><span class="lineNum">     126 </span>            :             when wait_interp =&gt;</a>
<a name="127"><span class="lineNum">     127 </span><span class="lineCov">          4 :                 if estim_valid then</span></a>
<a name="128"><span class="lineNum">     128 </span><span class="lineCov">          2 :                     if addr_high = &quot;11010101000&quot; then</span></a>
<a name="129"><span class="lineNum">     129 </span><span class="lineNoCov">          0 :                         p_state &lt;= rest;</span></a>
<a name="130"><span class="lineNum">     130 </span>            :                     </a>
<a name="131"><span class="lineNum">     131 </span>            :                     else</a>
<a name="132"><span class="lineNum">     132 </span><span class="lineCov">          2 :                         p_state &lt;= act_prbs;</span></a>
<a name="133"><span class="lineNum">     133 </span>            :                     end if;</a>
<a name="134"><span class="lineNum">     134 </span>            :                 else</a>
<a name="135"><span class="lineNum">     135 </span><span class="lineCov">          4 :                     p_state &lt;= wait_interp;                        </span></a>
<a name="136"><span class="lineNum">     136 </span>            :                     </a>
<a name="137"><span class="lineNum">     137 </span>            :                 end if;</a>
<a name="138"><span class="lineNum">     138 </span>            :         </a>
<a name="139"><span class="lineNum">     139 </span>            :             when act_prbs =&gt;</a>
<a name="140"><span class="lineNum">     140 </span><span class="lineNoCov">          0 :                 p_addr_low &lt;= addr_high;</span></a>
<a name="141"><span class="lineNum">     141 </span><span class="lineNoCov">          0 :                 p_addr_high &lt;= std_logic_vector(unsigned(addr_high) + 12);</span></a>
<a name="142"><span class="lineNum">     142 </span><span class="lineNoCov">          0 :                 hinf &lt;= hsup;</span></a>
<a name="143"><span class="lineNum">     143 </span><span class="lineNoCov">          0 :                 p_state &lt;= sup_pilot;</span></a>
<a name="144"><span class="lineNum">     144 </span><span class="lineNoCov">          0 :                 prbs_enable &lt;= '1';</span></a>
<a name="145"><span class="lineNum">     145 </span>            : </a>
<a name="146"><span class="lineNum">     146 </span>            :             when others =&gt; </a>
<a name="147"><span class="lineNum">     147 </span><span class="lineCov">          2 :                 p_state &lt;= rest;</span></a>
<a name="148"><span class="lineNum">     148 </span>            :                 </a>
<a name="149"><span class="lineNum">     149 </span>            :                 </a>
<a name="150"><span class="lineNum">     150 </span>            :         end case;</a>
<a name="151"><span class="lineNum">     151 </span>            : </a>
<a name="152"><span class="lineNum">     152 </span>            :     end process;</a>
<a name="153"><span class="lineNum">     153 </span>            :     </a>
<a name="154"><span class="lineNum">     154 </span>            : </a>
<a name="155"><span class="lineNum">     155 </span>            : end architecture;</a>
</pre>
      </td>
    </tr>
  </table>
  <br>

  <table width="100%" border=0 cellspacing=0 cellpadding=0>
    <tr><td class="ruler"><img src="../glass.png" width=3 height=3 alt=""></td></tr>
    <tr><td class="versionInfo">Generated by: <a href="http://ltp.sourceforge.net/coverage/lcov.php" target="_parent">LCOV version 1.14</a></td></tr>
  </table>
  <br>

</body>
</html>
